=== scipy/_lib/pyprima/pyprima/tests/requirements.txt ===
numpy
pycutest
pytest
pytest-cov
pytest-order
