=== debian/changelog ===
scipy (1.16.3-1) unstable; urgency=medium

  * New upstream release
    - applies fix_stats_bivariate_normal_cdf_PR23815.patch
  * hppa: skip all test_accuracy in TestTanhSinh (integrate module)
  * hurd-i386: skip test_tmax (test_mstats_basic.py)

 -- Drew Parsons <dparsons@debian.org>  Fri, 31 Oct 2025 20:06:04 +0100
